﻿var CharManagerModel = function () {

    var self = this;

    self.uiState = ko.observable('h'); // Initialize with home screen
    self.uiParam = null;
    self.charModel = ko.mapping.fromJS(CCharacterFactory.createEmptyCharacter());
    self.rndNum = new XRndNum();
    self.charManager = new XCharacterManager();

    // Setup routes
    self.sammy = $.sammy('#main', function()
    {
        this.notFound = function() { }

        this.get('#/:mid', function()
        {
            console.log(this.params['mid']);
            self.moduleId = this.params['mid'];
        });
    });

    /* Click Handlers */
    self.startStock = function()
    {
        console.log("STOCK");

    };

    self.openCharList = function()
    {
        console.log("CHAR LIST");

    };

    self.rollNewChar = function(x)
    {
        self.uiParam = x;
        self.rollAbilityScores();

        self.uiState('n');
    };

    self.cancelNewChar = function()
    {
        self.uiState('h');
    };

    self.startGame = function()
    {
        var c = ko.mapping.toJS(self.charModel);
        
        if (_.isEmpty(c.name))
        {
            vex.dialog.alert("You must give your character a name!");
            return;
        };

        self.charManager.save(c);
        //console.log(self.charModel());
        //var charJson = ko.mapping.toJSON(self.charModel);
       
        var url = "play.html#/" + self.moduleId + "/" + c.id;
        window.location = url;
    };

    self.rollAbilityScores = function()
    {
        var c = self.charModel;

        switch (self.uiParam)
        {
            case 'n':

                c.hardiness(self.rndNum.roll(3, 8));
                c.agility(self.rndNum.roll(3, 8));
                c.charisma(self.rndNum.roll(3, 8));

                c.spellAbilities.blast(self.rndNum.range(25, 75));
                c.spellAbilities.heal(self.rndNum.range(25, 75));
                c.spellAbilities.speed(self.rndNum.range(25, 75));
                c.spellAbilities.power(self.rndNum.range(25, 75));

                break;

            case 'm':

                c.hardiness(self.rndNum.roll(5, 8));
                c.agility(self.rndNum.roll(4, 8));
                c.charisma(self.rndNum.roll(3, 8));

                c.spellAbilities.blast(self.rndNum.range(45, 125));
                c.spellAbilities.heal(self.rndNum.range(45, 105));
                c.spellAbilities.speed(self.rndNum.range(45, 105));
                c.spellAbilities.power(self.rndNum.range(45, 105));

                c.weaponAbilities.axe(35);
                c.weaponAbilities.missile(25);
                c.weaponAbilities.club(40);
                c.weaponAbilities.spear(40);
                c.weaponAbilities.sword(30);

                break;

            case 's':

                c.hardiness(self.rndNum.roll(10, 8));
                c.agility(self.rndNum.roll(6, 8));
                c.charisma(self.rndNum.roll(3, 8));

                c.spellAbilities.blast(self.rndNum.range(75, 225));
                c.spellAbilities.heal(self.rndNum.range(75, 225));
                c.spellAbilities.speed(self.rndNum.range(75, 185));
                c.spellAbilities.power(self.rndNum.range(75, 185));

                c.weaponAbilities.axe(50);
                c.weaponAbilities.missile(50);
                c.weaponAbilities.club(60);
                c.weaponAbilities.spear(60);
                c.weaponAbilities.sword(50);

                break;
        }
    };

    self.init = function () {

        $("#tabs").tabs();
        $("button").button();

        vex.defaultOptions.className = 'vex-theme-default';

        self.sammy.run();
    };

    self.init();
};