//--------------------------------------------------------------
//
// Eamon Revolutions Role Playing Game
// Derek C. Jeter
//
//--------------------------------------------------------------

function XCmdHistory(historySizeParam)
{
    this.historySize = historySizeParam;

    var commandHistory = new Array();
    var commandHistoryIndex = 0;
    var lastCommand = "";

    this.add = function(c)
    {
        for (var i = 0; i < commandHistory.length; i++)
        {
            if (commandHistory[i] == c)
            {
                return; // Command is already in the history list
            }
        }

        commandHistory.splice(0, 0, c);
        commandHistoryIndex = 0;

        if (commandHistory.length > this.historySize)
        {
            commandHistory.pop();
        }

        lastCommand = c;
    };

    this.rotate = function()
    {
        if (commandHistory.length == 0)
        {
            return "";
        }

        var c = commandHistory[commandHistoryIndex];

        commandHistoryIndex++;

        if (commandHistoryIndex == commandHistory.length)
        {
            commandHistoryIndex = 0;
        }

        lastCommand = c;

        return c;
    };

    this.getLastCommand = function()
    {
        return lastCommand;
    };
}