// Test fixtures - Module rules

QUnit.test("Module Validator - name - valid", function(assert)
{
    var module = CreateFullMockModule();

    var v = new Validator();
    var errors = v.validateModule(module);

    assert.equal(errors.length, 0, "Error count");
});

QUnit.test("Module Validator - name - invalid", function(assert)
{
    var module = CreateFullMockModule();
    delete module.name;

    var v = new Validator();
    var errors = v.validateModule(module);

    assert.equal(errors.length, 1, "Error count");

    var error = errors[0];
    assert.equal(error.type, v.errorObjectType.module, "Error Type");
    assert.equal(error.number, module.info.serialNum, "Error Number")
    assert.equal(error.message, "Module contains invalid name property", "Error Message")
});

